<template>
  <div class="project-container">
    <div class="header">
      <el-button type="success" icon="Plus" @click="toProcess('add',{})">新增</el-button>
      <!--      <vue3-json-excel-->
      <!--          :json-data="dataList"-->
      <!--          :fields="fields"-->
      <!--          name="项目信息表.xlsx"-->
      <!--          style="margin-right: 5px;margin-left: 5px"-->
      <!--      >-->
      <!--        <el-button type="warning">导出</el-button>-->
      <!--      </vue3-json-excel>-->
      <el-button type="primary" icon="Filter" @click="showDrawer = true">筛选</el-button>
    </div>
    <div class="middle">
      <div class="card-box">
        <div class="box-left" @click="choose('')">
          <div class="font-left">
            <div>项目</div>
            <div>总数</div>
          </div>
          <div class="font-right">{{ search.num.total }}</div>
        </div>
        <div class="box-right">
          <div class="inbox" @click="choose(1)" style="box-shadow: rgba(132, 122, 253, 0.2) 0 3px 5px 0;"
               :class="{btn1: chooseType === 1}">
            <div class="top" style="background: linear-gradient(90deg, rgb(127, 118, 253), rgb(218, 180, 246));">
              <span class="top-right-font">基本信息</span>
            </div>
            <div class="bottom">
              <span class="top-right-font-bottom">{{ search.num.staging }}</span>
            </div>
          </div>
          <div class="inbox" @click="choose(2)" style="box-shadow: rgba(255, 142, 139, 0.15) 0 3px 5px 0;"
               :class="{btn2: chooseType === 2}">
            <div class="top" style="background: linear-gradient(90deg, rgb(255, 140, 138), rgb(239, 186, 141));">
              <span class="top-right-font">专家选用</span>
            </div>
            <div class="bottom">
              <span class="top-right-font-bottom">{{ search.num.expert }}</span>
            </div>
          </div>
          <div class="inbox" @click="choose(3)" style="box-shadow: rgba(222, 106, 169, 0.15) 0 3px 5px 0;"
               :class="{btn3: chooseType === 3}">
            <div class="top" style="background: linear-gradient(90deg, rgb(229, 119, 180), rgb(249, 159, 192));">
              <span class="top-right-font">项目审批</span>
            </div>
            <div class="bottom">
              <span class="top-right-font-bottom">{{ search.num.approval }}</span>
            </div>
          </div>
          <div class="inbox" @click="choose(4)" style="box-shadow: rgba(109, 177, 254, 0.2) 0 3px 5px 0;"
               :class="{btn4: chooseType === 4}">
            <div class="top" style="background: linear-gradient(90deg, rgb(54, 115, 255), rgb(124, 196, 242));">
              <span class="top-right-font">项目归档</span>
            </div>
            <div class="bottom">
              <span class="top-right-font-bottom">{{ search.num.end }}</span>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- 表格数据 -->
    <el-table v-loading="loading" :data="dataList" :border="true" ref="tableRef" :height="tableHeight"
              style="width: 100%;">
      <el-table-column label="序号" width="80" align="center" type="index"></el-table-column>
      <el-table-column label="项目编码" width="180" align="center" prop="projectCode"></el-table-column>
      <el-table-column label="申请时间" prop="createTime" align="center" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="出差事由" prop="projectName" align="center" :show-overflow-tooltip="true" />
      <el-table-column label="部门" prop="deptName" align="center" width="180"/>
      <el-table-column label="专家组组长" prop="expertName" align="center" width="120"/>
      <el-table-column label="专家组人数" prop="expertNum" align="center" width="120"/>
      <el-table-column label="当前状态" prop="state" align="center" width="200">
        <template #default="scope">
          <span>{{
              scope.row.state === 0 ? '暂存' : scope.row.state === 1 ? '选取专家' : scope.row.state === 2 ? '生成审批单' : scope.row.state === 3 ? '审批通过' : '完结'
            }}</span>
        </template>
      </el-table-column>
      <el-table-column fixed="right" label="操作" align="center" class-name="small-padding fixed-width" width="180">
        <template #default="scope">
          <el-button link type="primary" @click="toProcess('view',scope.row)">查看</el-button>
          <el-button link type="primary" v-if="scope.row.step !== 4" @click="toProcess('edit',scope.row)">编辑
          </el-button>
          <el-button link type="danger" v-if="scope.row.step !== 4" @click="del(scope.row)">删除</el-button>
          <el-button link v-if="scope.row.state === 4" type="primary" @click="downloadExcel(scope.row)">导出报销表
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <div class="pag-container">
      <el-pagination
          v-model:current-page="search.queryParams.pageNum"
          v-model:page-size="search.queryParams.pageSize"
          :page-sizes="[10,15,20,25]"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
      />
    </div>
    <el-drawer v-model="showDrawer" :direction="direction" :with-header="false" :size="size">
      <template #default>
        <div class="drawer">
          <el-form ref="drawerRef" class="register-form" label-position="top">
            <el-form-item label="时间选择">
              <el-date-picker
                  v-model="searchTime"
                  type="daterange"
                  @change="changeTime"
                  range-separator="至"
                  start-placeholder="开始日期"
                  end-placeholder="结束日期"
                  value-format="YYYY-MM-DD"
              />
            </el-form-item>
            <el-form-item label="项目名称">
              <el-input v-model.trim="search.queryParams.projectName" placeholder="请输入项目名称"></el-input>
            </el-form-item>
            <el-form-item label="部门名称">
<!--              <el-input v-model.trim="search.queryParams.deptName" placeholder="请输入部门名称"></el-input>-->
              <el-cascader
                  style="width: 100%"
                  clearable
                  v-model.trim="search.queryParams.deptId"
                  :show-all-levels="false"
                  placeholder="请选择部门"
                  :options="deptList"
                  :props="{ value: 'deptId',label: 'deptName',emitPath: false,checkStrictly: true}"></el-cascader>
            </el-form-item>
            <el-form-item label="项目编码">
              <el-input v-model.trim="search.queryParams.projectCode" placeholder="请输入项目编码"></el-input>
            </el-form-item>
          </el-form>
        </div>
      </template>
      <template #footer>

        <div style="display: flex;align-items: center;justify-content: space-between">
          <vue3-json-excel
              :json-data="expertList"
              :fields="fields"
              name="专家汇总表.xlsx"
          >
            <el-button type="primary" plain @click="handleExport">导出专家汇总表</el-button>
          </vue3-json-excel>
          <div>
            <el-button type="primary" @click="searchClick">查询</el-button>
            <el-button type="warning" @click="reset">重置</el-button>
            <el-button @click="confirmClick">取消</el-button>
          </div>
        </div>
      </template>
    </el-drawer>
  </div>

</template>

<script setup>
import {onMounted, reactive, ref} from "vue";
// import {delProject, getProjectList, getProjectStatistics} from "@/api/projectManage/project";
import {ElMessage, ElMessageBox} from "element-plus";
import Cookies from "js-cookie"
import {delProject, exportData, exportExpertData, getProjectList, getProjectNum} from "@/api/projectManage";
// import * as XLSX from 'xlsx';
import XLSX from 'xlsx-js-style';
import {listDept} from "@/api/system/dept";
const { proxy } = getCurrentInstance();

const router = useRouter();

const loading = ref(false);
const direction = ref('rtl');
const showDrawer = ref(false);
const size = ref('400px')
const props = {
  expandTrigger: 'hover',
  value: 'name',
  label: 'name'
}
const search = reactive({
  queryParams: {
    pageNum: 1,
    pageSize: 20,
    projectName: '',
    projectDateStart: '',
    projectDateEnd: '',
    step: null,
    deptId: null,
    projectCode: ''
  },
  num: {
    approval: 0,
    end: 0,
    expert: 0,
    staging: 0,
    total: 0
  }
});

const expertList = ref([])
// 导出表格
const fields = ref({
  '姓名':'expertName',
  '处室':'deptName',
  '专家费': 'expertFee',
  '交通费': 'travelExpenses',
  '住宿费':'accommodationFee',
  '申请时间': 'createTime',
  '事由': 'projectName',
  '发现重大隐患':'majorDangers',
  '发现一般隐患': 'generalHazards'

});

const searchTime = ref([]);
const area = ref([]);
const stateList = ref([
  {
    id: 1,
    label: '基本信息'
  },
  {
    id: 2,
    label: '专家选用'
  },
  {
    id: 3,
    label: '项目审批'
  },
  {
    id: 4,
    label: '项目归档'
  },
])
const tableRef = ref(null);
const tableHeight = ref(0);
const dataList = ref([]);
const deptList = ref([])
const total = ref(0);
const isAgency = ref(false);
onMounted(() => {
  Cookies.remove('projectId')
  Cookies.remove('end')
  Cookies.remove('btn')
  getList()
  getDeptList()
  getStatistics()
  exportEData()
  // getArea();
  // getBusinessList();
  // getRiskList();
  tableHeight.value = window.innerHeight - tableRef.value.$el.offsetTop - 170;
  // 监听浏览器高度变化
  window.onresize = () => {
    tableHeight.value = window.innerHeight - tableRef.value.$el.offsetTop - 170;
  };
  // const userInfo = JSON.parse(Cookies.get('userInfo'))
  // isAgency.value = userInfo.identity === 1;

});
const chooseType = ref('');
const choose = (val) => {
  chooseType.value = val;
  search.queryParams.step = val;
  getList();
}
const getList = async () => {
  loading.value = true;
  const res = await getProjectList(search.queryParams);
  if (res.code == 200) {
    dataList.value = res.rows
    total.value = res.total
    loading.value = false;
  } else {
    ElMessage.warning(res.message)
  }
}

const exportEData = async () => {
  const {pageSize,pageNum,step,...data} = search.queryParams
  const res = await exportExpertData(data);
  if (res.code == 200) {

    if(res.data && res.data.length > 0){
      expertList.value = res.data
    }else {
      expertList.value = []
    }
  } else {
    ElMessage.warning(res.message)
  }
}
const handleExport = () => {
  if(expertList.value && expertList.value.length == 0){
    ElMessage.warning('暂无数据导出')
  }
}
function getDeptList() {
  listDept({
    deptName: undefined,
    status: undefined
  }).then(response => {
    deptList.value = proxy.handleTree(response.data, "deptId",'parentId','children');
  });
  console.log(deptList.value,999)
}

const getStatistics = async () => {
  const res = await getProjectNum();
  if (res.code == 200) {
    search.num = res.data
  } else {
    ElMessage.warning(res.message)
  }
}
const handleSizeChange = (val) => {
  search.queryParams.pageNum = 1;
  search.queryParams.pageSize = val
  getList()
}
const handleCurrentChange = (val) => {
  search.queryParams.pageNum = val
  getList()
}
const toProcess = (type, value, toPath) => {
  value.type = type;
  router.push({path: '/process', query: {id: value.id, type: type, toPath: toPath, process: value.step}});
}

const del = (val) => {
  ElMessageBox.confirm(
      '确定删除此条数据？',
      '提示',
      {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      })
      .then(async () => {
        const res = await delProject(val.id)
        if (res.code == 200) {
          ElMessage.success('数据删除成功')
          await getList()
          await getStatistics()

        } else {
          ElMessage.warning(res.msg)
        }
      })
}
const confirmClick = () => {
  reset()
  showDrawer.value = false;
}
const changeTime = (value) => {
  if (!value) {
    search.queryParams.projectDateStart = ""
    search.queryParams.projectDateEnd = ""
  }
}

const downloadExcel = async (row) => {
  const res = await exportData({projectId: row.id})
  if (res.code == 200) {
    // 定义标题
    const title = [[`自治区应急管理厅外聘专家劳务费发放表（项目编码${row.projectCode}）`]]
    // 固定一行：填报处室和单位
    const fixedHeader = [
      ["填报处室：" + row.deptName, "", "", "", "", "单位：元", "", "", "", "","", "",""]
    ]
    if(res.data && res.data[0] && Array.isArray(res.data[0].projectExpertExportResps) && res.data[0].projectExpertExportResps.length>0){
      let mainData = res.data[0].projectExpertExportResps
      const data = mainData.map((item,index)=>{
        return [index+1,item.name,item.companyName,item.title,item.idCard,item.freightBasis,item.billingDuration,item.taxExpertFee,item.incomeTaxPayable,item.travelExpenses,item.accommodationFee,item.openBank,item.bankCard]
      })
      console.log(data,'data')
      // 定义表头
      const headers = [
        ["序号", "姓名", "工作单位", "职称", "身份证号", "计费标准", "计费时长", "专家费", "应缴税费", "交通费", "住宿费","开户银行", "卡号"]
      ]
      // 固定一行：经办人和负责人
      const footer = [
        ["经办人：", "", "", "", "", "处室负责人：", "", `合计：${data.reduce((accumulator, currentValue) => {
          return accumulator + currentValue[7]
        }, 0).toFixed(2)}`,`合计：${data.reduce((accumulator, currentValue) => {
          return accumulator + currentValue[8]
        }, 0).toFixed(2)}`,"",""]
      ]
      // 创建工作表
      const ws = XLSX.utils.aoa_to_sheet([
        ...title,        // 标题
        ...fixedHeader,  // 填报处室和单位
        ...headers,      // 表头
        ...data,         // 数据
        ...footer        // 经办人和负责人
      ])
      // 获取数据的总行数
      const dataRowCount = data.length;
      // 合并单元格的范围
      ws['!merges'] = [
        { s: { r: 0, c: 0 }, e: { r: 0, c: 12 } },  // 合并标题：第1行 0列到12列
        { s: { r: 1, c: 0 }, e: { r: 1, c: 4 } },  // 合并填报处室：第2行 第0列到4列
        { s: { r: 1, c: 5 }, e: { r: 1, c: 12 } },  // 合并单位：第2行 第5列到12列
        { s: { r: 3 + dataRowCount, c: 0 }, e: { r: 3 + dataRowCount, c: 4 } },  // 合并经办人：最后一行的第0列到4列
        { s: { r: 3 + dataRowCount, c: 5 }, e: { r: 3 + dataRowCount, c: 6} },  // 合并负责人：最后一行的第5列到+6列
      ]
      // 设置标题
      if (!ws['A1']) ws['A1'] = {}; // 确保 A1 单元格存在
      ws['A1'].s = {
        alignment: { horizontal: 'center', vertical: 'center' },
        font: { bold: true, sz: 16 }
      }
      // 设置填报处室和单位左对齐
      if (!ws['A2']) ws['A2'] = {}  // 填报处室第一列
      if (!ws['F2']) ws['F2'] = {}  // 单位第一列
      ws['A2'].s = ws['F2'].s = {
        alignment: { horizontal: 'left', vertical: 'center' }
      };
      // 设置数据区（包括填报处室、单位、数据行和最后一行）为左对齐
      const totalRows = 3 + dataRowCount + 1; // 标题、固定行和数据行的总数
      for (let r = 3; r <= totalRows; r++) {  // 遍历每一行
        for (let c = 0; c < 13; c++) {  // 遍历每一列
          const cellRef = `${String.fromCharCode(65 + c)}${r}`;
          if (!ws[cellRef]) ws[cellRef] = {};  // 确保单元格存在
          ws[cellRef].s = {
            alignment: { horizontal: 'center', vertical: 'center' } // 设置居中对齐
          };
        }
      }
      // 设置表头居中并加粗
      const colCount = headers[0].length;  // 表头的列数
      for (let i = 0; i < colCount; i++) {
        const cellRef = `${String.fromCharCode(65 + i)}3`;  // 从第3行开始设置表头
        if (!ws[cellRef]) ws[cellRef] = {};  // 确保单元格存在
        ws[cellRef].s = {
          alignment: { horizontal: 'center', vertical: 'center' }, // 表头居中
          font: { bold: true }  // 设置加粗
        };
      }
      // 设置最后一行（经办人、负责人）左对齐
      const lastRowStart = 3 + dataRowCount;
      for (let c = 0; c < 13; c++) {
        const cellRef = `${String.fromCharCode(65 + c)}${lastRowStart + 1}`;
        console.log(cellRef,'ref')
        if (!ws[cellRef]) ws[cellRef] = {};  // 确保单元格存在
        if(cellRef == 'H'+ (4 + dataRowCount) || cellRef == 'I'+ (4 + dataRowCount)){
          ws[cellRef].s = {
            alignment: { horizontal: 'center', vertical: 'center' } // 设置居中对齐
          }
        }else{
          ws[cellRef].s = {
            alignment: { horizontal: 'left', vertical: 'center' } // 设置为左对齐
          }
        }
      }
      // 设置列宽，计算每列的最大宽度
      const MIN_COL_WIDTH = 60;
      const colWidths = [];
      for (let c = 0; c < 13; c++) {
        let maxLength = 0;
        // 计算每列最大单元格内容长度
        for (let r = 0; r < totalRows; r++) {
          const cellRef = `${String.fromCharCode(65 + c)}${r + 1}`; // 获取每个单元格的引用
          const cell = ws[cellRef];
          if (cell && cell.v) {
            if(cell.v == '序号'){
              maxLength = 1
            }else {
              maxLength = Math.max(maxLength, cell.v.toString().length);
            }

          }
        }
        // 根据最大长度设置列宽，添加额外的空间
        colWidths[c] = { wpx: Math.max(maxLength * 15, MIN_COL_WIDTH) }; // 你可以根据需要调整乘数
      }

      // 设置工作表的列宽
      ws['!cols'] = colWidths;

      // 设置行高，统一调整上下间距
      const rowHeight = 28; // 设置每一行的行高（可以根据需要调整）
      for (let r = 0; r < totalRows; r++) {
        ws['!rows'] = ws['!rows'] || [];
        ws['!rows'][r] = { hpx: rowHeight };  // 设置行高，单位是像素
      }
      // 创建工作簿
      const wb = XLSX.utils.book_new();
      XLSX.utils.book_append_sheet(wb, ws, "Sheet1")
      // 使用 Blob 和 URL 触发文件下载
      const wbout = XLSX.write(wb, { bookType: 'xlsx', type: 'array' })
      const blob = new Blob([wbout], { type: 'application/octet-stream' })
      const url = URL.createObjectURL(blob)
      // 创建下载链接并触发下载
      const a = document.createElement('a')
      a.href = url;
      a.download = `${row.deptName}-${row.updateTime.substring(0,10)}.xlsx`  // 设置下载文件名
      document.body.appendChild(a)
      a.click();
      document.body.removeChild(a)
      // 释放 URL 对象
      URL.revokeObjectURL(url)
    }
  } else {
    ElMessage.warning(res.msg)
  }
}

const searchClick = () => {
  if (searchTime.value && searchTime.value.length > 0) {
    search.queryParams.projectDateStart = searchTime.value[0]
    search.queryParams.projectDateEnd = searchTime.value[1]
  }
  getList();
  getStatistics();
  exportEData()
  showDrawer.value = false;
}
const reset = () => {
  searchTime.value = [];
  search.queryParams = {
    pageNum: 1,
    pageSize: 20,
    projectName: '',
    projectDateStart: '',
    projectDateEnd: '',
    step: null,
    deptId: null,
    projectCode: ''
  }
  chooseType.value = '';
  getList();
  getStatistics();

}

</script>

<style scoped lang="scss">
.project-container {
  .header {
    margin: 15px 10px;
    display: flex;
    align-items: center;
    justify-content: flex-end;
  }

  .middle {
    height: 99px;
    margin-bottom: 20px;
  }

  .card-box {
    margin: 20px;
    height: 99px;
    background: #fff;
    box-shadow: 0 3px 10px 0 rgba(62, 62, 62, .25);
    border-radius: 10px;
    display: flex;

    .box-left {
      width: 20%;
      min-width: 200px;
      height: 99px;
      background: #fff;
      box-shadow: 0 0 5px 0 rgba(62, 62, 62, .2);
      border-radius: 10px;
      display: flex;
      margin-left: -15px;
      align-items: center;
      cursor: pointer;
      padding-left: 2%;

      .font-left {
        width: 40px;
        height: 40px;
        font-size: 20px;
        font-weight: 400;
        color: #9198ad;
        line-height: 18px;
        font-family: fantasy;
      }

      .font-right {
        position: relative;
        left: 7%;
        top: -3px;
        height: 40px;
        font-size: 36px;
        font-family: fantasy;
        font-weight: 400;
        color: #222733;
      }
    }

    .box-left:hover {
      border: 1px solid #4378f1
    }

    .box-right {
      width: 80%;
      height: 99px;
      border-radius: 10px;
      margin-left: 15px;
      display: flex;
      align-items: center;
      justify-content: space-between;

      .inbox {
        width: 23%;
        height: 76px;
        background: #fff;
        border-radius: 5px;
        cursor: pointer;

        .top {
          width: 100%;
          height: 39px;
          border-top-left-radius: 5px;
          border-top-right-radius: 5px;

          .top-right-font {
            font-size: 16px;
            color: #fff;
            line-height: 39px;
            margin-left: 10px;
          }
        }

        .bottom {
          height: 37px;

          .top-right-font-bottom {
            font-size: 20px;
            color: #333;
            line-height: 37px;
            margin-left: 20px;
            font-family: fantasy;
          }
        }
      }

      .inbox:nth-child(1):hover {
        border: 1px solid #dab4f6;
      }

      .inbox:nth-child(2):hover {
        border: 1px solid #efba8d;
      }

      .inbox:nth-child(3):hover {
        border: 1px solid #f99fc0;
      }

      .inbox:nth-child(4):hover {
        border: 1px solid #7cc4f2;
      }

      .inbox:nth-child(5):hover {
        border: 1px solid #72e8c8;
      }
    }
  }

  .btn1 {
    border: 1px solid #dab4f6;
  }

  .btn2 {
    border: 1px solid #efba8d;
  }

  .btn3 {
    border: 1px solid #f99fc0;
  }

  .btn4 {
    border: 1px solid #7cc4f2;
  }

  .btn5 {
    border: 1px solid #72e8c8;
  }

  .pag-container {
    float: right;
    margin-top: 20px;
  }

  .process1 {
    border-radius: 5px;
    color: rgb(255, 255, 255);
    padding: 5px 10px;
    background: linear-gradient(90deg, rgb(127, 118, 253), rgb(218, 180, 246));
  }

  .process2 {
    background: linear-gradient(90deg, rgb(255, 140, 138), rgb(239, 186, 141));
  }

  .process3 {
    background: linear-gradient(90deg, rgb(229, 119, 180), rgb(249, 159, 192));;
  }

  .process4 {
    background: linear-gradient(90deg, rgb(54, 115, 255), rgb(124, 196, 242));;
  }

  .process5 {
    background: linear-gradient(90deg, rgb(0, 195, 151), rgb(114, 232, 200));;
  }

  .drawer {
    :deep(.el-form .el-form-item__label) {
      font-size: 15px;
    }
  }

}
</style>
